config/routes.rb
Rails.application.routes.draw do
  resources :tasks do
    patch :change_status, on: :member
  end
  root "tasks#index"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/task.rb
class Task < ApplicationRecord
  validates_presence_of :name
  enum status: {incomplete: 0, complete: 1 }
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/tasks_controller.rb
class TasksController < ApplicationController
  before_action :set_task, only: %i[ show edit update destroy change_status]

  
  def index
    @tasks = Task.where(status: params[:status].presence || 'incomplete')
  end

  def show
  end

  def edit
  end

  def create
    @task = Task.new(task_params)

    respond_to do |format|
      if @task.save
        format.turbo_stream { render(turbo_stream: turbo_stream.prepend(:tasks, @task)) }
        format.html { redirect_to tasks_url, notice: "Todo was successfully created." }
      else
        format.turbo_stream { render turbo_stream: turbo_stream.replace("#{helpers.dom_id(@task)}_form", partial: "form", locals: { task: @task }) }
      end
    end
  end

  def update
    respond_to do |format|
      if @task.update(task_params)
        format.html { redirect_to tasks_url, notice: "Todo-Item was successfully updated." }
      else
        format.turbo_stream { render turbo_stream: turbo_stream.replace("#{helpers.dom_id(@task)}_form", partial: "form", locals: { task: @task }) }
        format.html { render :edit, status: :unprocessable_entity }
      end
    end
  end

  def destroy
    @task.destroy

    respond_to do |format|
      format.turbo_stream { render turbo_stream: turbo_stream.remove("#{helpers.dom_id(@task)}_container") }
      format.html { redirect_to tasks_url, notice: "Task was successfully destroyed." }
    end
  end

  def change_status
    @task.update(status: task_params[:status])
    respond_to do |format|
      format.turbo_stream { render turbo_stream: turbo_stream.remove("#{helpers.dom_id(@task)}_container") }
      format.html { redirect_to tasks_path, notice: "Updated task status." }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_task
      @task = Task.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def task_params
      params.require(:task).permit(:name, :status)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/tasks_helper.rb
module TasksHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>MYApp</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>
    <%#= stylesheet_link_tag "tailwind", "inter-font", "data-turbo-track": "reload" %>
    <%= stylesheet_link_tag "tailwind", "inter-font", "data-turbo-track": "reload" %>

    <%= stylesheet_link_tag "application.tailwind", "data-turbo-track": "reload" %>
    <%= javascript_importmap_tags %>
  </head>

  <body>
    <main class="container flex">
      <% if notice.present? %>
        <p class="py-2 px-3 bg-green-50 mb-5 text-green-500 font-medium rounded-lg inline-block" id="notice">
          <%= notice %>
        </p>
      <% end %>
      <%= yield %>
    </main>
  </body>
</html>

app/views/tasks/_form.html.slim
= form_with(model: task, data: { controller: "form", action: 'turbo:submit-end->form#resetForm' }, id: "#{dom_id(task)}_form") do |form|
  - if task.errors.any?
    #error_explanation.bg-red-50.text-red-500.px-3.py-2.font-medium.rounded-lg.mt-3.mb-5
      h2
        = pluralize(task.errors.count, "error")
        |  prohibited this task from being saved:
      ul
        - task.errors.each do |error|
          li
            = error.full_message
  .w-full.flex
    = form.text_field :name, class: "block w-full rounded-full mr-2 sm:text-sm border-gray-300 ", placeholder: "Add a new task..."
    = form.submit class: "-ml-px relative px-4 py-2 border border-blue-600 text-sm font-medium rounded-full text-white bg-blue-600 hover:bg-blue-700"

app/views/tasks/_task.html.slim
| <li id="
= "#{dom_id(task)}_container"
| " class="py-2 px-4 border-b border-gray-300"> 
= turbo_frame_tag dom_id(task) do
  .flex.justify-between.items-center.space-x-2
    = link_to task.name, edit_task_path(task), class: task.complete? ? 'line-through' : ''
    .flex.justify-end.space-x-3
      - if task.complete?
        = button_to change_status_task_path(task, task: { status: 'incomplete' }), class: "bg-indigo-600 px-4 py-2 rounded hover:bg-green-700", method: :patch do
          span.sr-only
            | Mark as incomplete
          svg.h-5.w-5.text-white[xmlns="http://www.w3.org/2000/svg" viewbox="0 0 20 20" fill="currentColor"]
            path[fill-rule="evenodd" d="M10 18a8 8 0 100-16 8 8 0 000 16zm3.707-9.293a1 1 0 00-1.414-1.414L9 10.586 7.707 9.293a1 1 0 00-1.414 1.414l2 2a1 1 0 001.414 0l4-4z" clip-rule="evenodd"]
      - else
        = button_to change_status_task_path(task, task: { status: 'complete' }), class: "bg-indigo-600 px-4 py-2 rounded hover:bg-green-700", method: :patch do
          span.sr-only
            | Mark as complete
          svg.h-5.w-5.text-white[xmlns="http://www.w3.org/2000/svg" viewbox="0 0 20 20" fill="currentColor"]
            path[fill-rule="evenodd" d="M10 18a8 8 0 100-16 8 8 0 000 16zm3.707-9.293a1 1 0 00-1.414-1.414L9 10.586 7.707 9.293a1 1 0 00-1.414 1.414l2 2a1 1 0 001.414 0l4-4z" clip-rule="evenodd"]
      div[data-controller="confirmation"]
        = button_to task, class: "bg-red-600 px-4 py-2 rounded hover:bg-red-700", method: :delete, data: { action: "click->confirmation#delete" } do
          span.sr-only
            | Delete
          svg.h-5.w-5.text-white[xmlns="http://www.w3.org/2000/svg" viewbox="0 0 20 20" fill="currentColor" title="Delete todo"]
            path[fill-rule="evenodd" d="M9 2a1 1 0 00-.894.553L7.382 4H4a1 1 0 000 2v10a2 2 0 002 2h8a2 2 0 002-2V6a1 1 0 100-2h-3.382l-.724-1.447A1 1 0 0011 2H9zM7 8a1 1 0 012 0v6a1 1 0 11-2 0V8zm5-1a1 1 0 00-1 1v6a1 1 0 102 0V8a1 1 0 00-1-1z" clip-rule="evenodd"]

app/views/tasks/edit.html.slim
= turbo_frame_tag dom_id(@task) do
  = render "form", task: @task

app/views/tasks/index.html.slim
- if notice.present?
  p#notice.py-2.px-3.bg-green-50.mb-5.text-green-500.font-medium.rounded-lg.inline-block
    = notice
.to-do-container.mx-auto.w-1/2.bg-indigo-100.p-3.m-40
  h2.text-3xl.text-gray-900.font-semibold
    |  Todo List
  = turbo_frame_tag "tasks-container", class: "block bg-indigo-100 max-w-2xl w-full py-8 px-4 border border-gray-200 rounded shadow-sm" do
    .border-b.border-gray-200.w-full
      ul.flex.space-x-2.justify-center.font-semibold.pb-3
        li.bg-indigo-800.rounded-lg.p-3.text-white class="hover:bg-indigo-400 hover:text-black flex"
          = link_to "Incomplete",
          -             tasks_path(status: "incomplete")
        li.bg-indigo-800.rounded-md.p-3.text-white class="hover:bg-indigo-400 hover:text-black flex"
          = link_to "Complete",
          -             tasks_path(status: "complete")
    - unless params[:status] == "complete"
      .py-2.px-4
        = render "form", task: Task.new
    ul#tasks
      = render @tasks